/*
 * This holds a few functions that are used most often.
 * Note the use of constants.getParentUrl() to make the whole system location independent.
 */

utilitiesBase=constants.getParentUrl();
print ('utilitiesBase=',utilitiesBase,'\n');


/** 
 * This looks in between all events coming for the ones of type InvocationEvent
 */
function waitInvocation ( )
  {
  anEvent = null;
  jsConsole.statusSet ('Waiting for an Event');

  while (   (anEvent = jsEvent.get()) != null )
     {
     // We wait for Invocation Events
     if ( anEvent.getClass() == "class bluej.extensions.event.InvocationEvent" ) break;
     }

  jsConsole.statusSet ('Event Received');
  return anEvent;
  }


/** 
 * This looks in between all events coming for the ones of type AppEvent
 * this one has a timeout. Once the timeout has expired null will be returned.
 */
function waitAppEvent ( msecTimeout )
  {
  anEvent = null;
  jsConsole.statusSet ('Waiting for ApplicationEvent');

  while (   (anEvent = jsEvent.get(msecTimeout)) != null )
    {
    print ('Got event=',anEvent,'\n');
    if ( anEvent.getClass() == "class bluej.extensions.event.ApplicationEvent" ) break;
    }

  // It may return null, but who cares !
  return anEvent;
  }



/**
 * This function uses reflection to list all methods of a given object.
 * You can try to use with the bluej object.
 */
function listMethods ( anObject )
  {
  methods=anObject.getClass().getDeclaredMethods();	
  print ('method list for class: '+anObject.getClass().getName(),'\n');

  for ( index=0; index < methods.length; index++ )
     {
     print (methods[index].getName(),'\n');
     }
  }



/*
 * This closes all possibly open projects
 */
function closeAllProjects ()
   {
   jsConsole.outputClear();
   alist = bluej.getOpenProjects();
   for ( index=0; index < alist.length; index ++ )
      {
      print ('-- Closing Project name=',alist[index].getName(),'\n');
      alist[index].close();
      }
   }


function soapEcho ( aLine )
  {
  print ('Something coming from soap',aLine,'\n');
  soapEvent.put ('soapEcho: '+aLine);
  }


/*
 * this allows to choose a directory where to save a project
 */
function chooseDirectory()
   {	
   fileChoose = new Packages.javax.swing.JFileChooser();
   fileChoose.setFileSelectionMode (Packages.javax.swing.JFileChooser.DIRECTORIES_ONLY);

   frame=bluej.getCurrentFrame();
   if ( frame == null ) 
    {
    print ('Got empty frame\n');
    return null;
    }

   risul=fileChoose.showSaveDialog(frame);
   if ( risul != 0 ) return null;

   return fileChoose.getSelectedFile();
   }


/**
 * This is not kind on the user, you can make it to be kinder....
 */
function soapLoadProject (  )
  {
  saveDir=chooseDirectory();
  if ( saveDir != null )
    {	
    fromStream=utils.inputStreamGet(htmlBase+'/../shapes.zip');
    utils.transferProject (saveDir,fromStream);
    shapes = new java.io.File (saveDir+'/shapes');
    bluej.openProject (shapes );
    
    soapEvent.put ('done');   // This tell to IE that the project is loaded.
    }
  }
  

function soapWaitObjectClass ( objectClassName )
   {	
   for (;;)
      {
      waitClass = waitInvocation();
      if ( waitClass == null ) break;
      if ( waitClass.getClassName() == objectClassName ) break;
      print ('soapWaitObjectClass got=', waitClass.getClassName(), ' want=',objectClassName,'\n');
      }

  soapEvent.put ('done');
  }


function soapWaitObjectMethod ( objectMethodName )
   {	
   for (;;)
      {
      waitClass = waitInvocation();
      if ( waitClass.getMethodName() == objectMethodName ) break;
      print ('soapWaitObjectMethod got=', waitClass.getMethodName(), ' want=',objectMethodName,'\n');
      }

  soapEvent.put ('done');
  }


function bluejClose()
   {
   html.load (utilitiesBase+'/closebluej.html');
   jsleep (5000);
   java.lang.System.exit(0);
   }
